Index: /LMDZ5/branches/LMDZ_tree_FC/libf/dynphy_lonlat/phylmd/etat0phys_netcdf.F90
===================================================================
--- /LMDZ5/branches/LMDZ_tree_FC/libf/dynphy_lonlat/phylmd/etat0phys_netcdf.F90	(revision 2924)
+++ /LMDZ5/branches/LMDZ_tree_FC/libf/dynphy_lonlat/phylmd/etat0phys_netcdf.F90	(revision 2925)
@@ -43,5 +43,6 @@
     sig1, ftsol, clwcon, fm_therm, wake_Cstar,  pctsrf,  entr_therm,radpas, f0,&
     zmax0,fevap, rnebcon,falb_dir, wake_fip,    agesno,  detr_therm, pbl_tke,  &
-    phys_state_var_init
+    phys_state_var_init, ql_ancien, qs_ancien, prlw_ancien, prsw_ancien, &
+    prw_ancien
   USE comconst_mod, ONLY: pi, dtvr
 
@@ -201,4 +202,9 @@
   t_ancien   = 273.15
   q_ancien   = 0.
+  ql_ancien = 0.
+  qs_ancien = 0.
+  prlw_ancien = 0.
+  prsw_ancien = 0.
+  prw_ancien = 0.
   agesno     = 0.
 
Index: /LMDZ5/branches/LMDZ_tree_FC/libf/phylmd/cloudth_mod.F90
===================================================================
--- /LMDZ5/branches/LMDZ_tree_FC/libf/phylmd/cloudth_mod.F90	(revision 2924)
+++ /LMDZ5/branches/LMDZ_tree_FC/libf/phylmd/cloudth_mod.F90	(revision 2925)
@@ -311,5 +311,7 @@
       ! (J Jouhaud, JL Dufresne, JB Madeleine)
       REAL,SAVE :: vert_alpha
+      !$OMP THREADPRIVATE(vert_alpha)
       LOGICAL, SAVE :: firstcall = .TRUE.
+      !$OMP THREADPRIVATE(firstcall)
       
       REAL zpdf_sig(ngrid),zpdf_k(ngrid),zpdf_delta(ngrid)
@@ -858,6 +860,8 @@
       ! Change the width of the PDF used for vertical subgrid scale heterogeneity
       ! (J Jouhaud, JL Dufresne, JB Madeleine)
-      REAL,SAVE :: vert_alpha
+      REAL,SAVE :: vert_alpha, vert_alpha_th
+      !$OMP THREADPRIVATE(vert_alpha, vert_alpha_th)
       LOGICAL, SAVE :: firstcall = .TRUE.
+      !$OMP THREADPRIVATE(firstcall)
 
       REAL zpdf_sig(ngrid),zpdf_k(ngrid),zpdf_delta(ngrid)
@@ -893,4 +897,9 @@
         CALL getin_p('cloudth_vert_alpha',vert_alpha)
         WRITE(*,*) 'cloudth_vert_alpha = ', vert_alpha
+        ! The factor used for the thermal is equal to that of the environment
+        !   if nothing is explicitly specified in the def file
+        vert_alpha_th=vert_alpha
+        CALL getin_p('cloudth_vert_alpha_th',vert_alpha_th)
+        WRITE(*,*) 'cloudth_vert_alpha_th = ', vert_alpha_th
         firstcall=.FALSE.
       ENDIF
@@ -997,5 +1006,5 @@
       qltot(ind1,ind2)=fraca(ind1,ind2)*qlth(ind1,ind2)+(1.-1.*fraca(ind1,ind2))*qlenv(ind1,ind2)
 
-      ELSE IF (iflag_cloudth_vert == 3) THEN
+      ELSE IF (iflag_cloudth_vert >= 3) THEN
 
 !-------------------------------------------------------------------------------
@@ -1006,6 +1015,11 @@
 !      deltasenv=aenv*ratqs(ind1,ind2)*zqsatenv(ind1,ind2)
 !      deltasth=ath*ratqs(ind1,ind2)*zqsatth(ind1,ind2)
-      deltasenv=aenv*vert_alpha*sigma1s
-      deltasth=ath*vert_alpha*sigma2s
+      IF (iflag_cloudth_vert == 3) THEN
+        deltasenv=aenv*vert_alpha*sigma1s
+        deltasth=ath*vert_alpha_th*sigma2s
+      ELSE IF (iflag_cloudth_vert == 4) THEN
+        deltasenv=vert_alpha*sigma1s
+        deltasth=vert_alpha_th*sigma2s
+      ENDIF
       
       xenv1=-(senv+deltasenv)/(sqrt(2.)*sigma1s)
@@ -1049,5 +1063,5 @@
 
 
-      ENDIF ! of if (iflag_cloudth_vert==1 or 3)
+      ENDIF ! of if (iflag_cloudth_vert==1 or 3 or 4)
 
       if (cenv(ind1,ind2).lt.1.e-10.or.cth(ind1,ind2).lt.1.e-10) then
Index: /LMDZ5/branches/LMDZ_tree_FC/libf/phylmd/comsoil.h
===================================================================
--- /LMDZ5/branches/LMDZ_tree_FC/libf/phylmd/comsoil.h	(revision 2924)
+++ /LMDZ5/branches/LMDZ_tree_FC/libf/phylmd/comsoil.h	(revision 2925)
@@ -3,5 +3,7 @@
 !
 
-      common /comsoil/inertie_sol,inertie_sno,inertie_ice
-      real inertie_sol,inertie_sno,inertie_ice
+      common /comsoil/inertie_sol,inertie_sno,inertie_sic,inertie_lic,  &
+     &                iflag_sic
+      real inertie_sol,inertie_sno,inertie_sic,inertie_lic
+      integer iflag_sic
 !$OMP THREADPRIVATE(/comsoil/)
Index: /LMDZ5/branches/LMDZ_tree_FC/libf/phylmd/conf_phys_m.F90
===================================================================
--- /LMDZ5/branches/LMDZ_tree_FC/libf/phylmd/conf_phys_m.F90	(revision 2924)
+++ /LMDZ5/branches/LMDZ_tree_FC/libf/phylmd/conf_phys_m.F90	(revision 2925)
@@ -173,5 +173,7 @@
     REAL,SAVE :: exposant_glace_omp
     REAL,SAVE :: rei_min_omp, rei_max_omp
-    REAL,SAVE :: inertie_sol_omp,inertie_sno_omp,inertie_ice_omp
+    INTEGER,SAVE :: iflag_sic_omp
+    REAL,SAVE :: inertie_sol_omp,inertie_sno_omp,inertie_sic_omp
+    REAL,SAVE :: inertie_lic_omp
     REAL,SAVE :: qsol0_omp
     REAL,SAVE :: evap0_omp
@@ -1137,11 +1139,27 @@
     !-----------------------------------------------------------------------
     !
-    !Config Key  = inertie_ice
+    !Config Key  = iflag_sic
+    !Config Desc =  
+    !Config Def  = 0
+    !Config Help = 
+    !
+    iflag_sic_omp = 0
+    CALL getin('iflag_sic',iflag_sic_omp)
+    !
+    !Config Key  = inertie_sic
     !Config Desc =  
     !Config Def  = 2000.
     !Config Help = 
     !
-    inertie_ice_omp = 2000.
-    CALL getin('inertie_ice',inertie_ice_omp)
+    inertie_sic_omp = 2000.
+    CALL getin('inertie_sic',inertie_sic_omp)
+    !
+    !Config Key  = inertie_lic
+    !Config Desc =  
+    !Config Def  = 2000.
+    !Config Help = 
+    !
+    inertie_lic_omp = 2000.
+    CALL getin('inertie_lic',inertie_lic_omp)
     !
     !Config Key  = inertie_sno
@@ -2154,6 +2172,8 @@
     evap0 = evap0_omp
     albsno0 = albsno0_omp
+    iflag_sic = iflag_sic_omp
     inertie_sol = inertie_sol_omp
-    inertie_ice = inertie_ice_omp
+    inertie_sic = inertie_sic_omp
+    inertie_lic = inertie_lic_omp
     inertie_sno = inertie_sno_omp
     rad_froid = rad_froid_omp
@@ -2572,6 +2592,8 @@
     write(lunout,*)' evap0 = ', evap0
     write(lunout,*)' albsno0 = ', albsno0
+    write(lunout,*)' iflag_sic = ', iflag_sic
     write(lunout,*)' inertie_sol = ', inertie_sol
-    write(lunout,*)' inertie_ice = ', inertie_ice
+    write(lunout,*)' inertie_sic = ', inertie_sic
+    write(lunout,*)' inertie_lic = ', inertie_lic
     write(lunout,*)' inertie_sno = ', inertie_sno
     write(lunout,*)' f_cdrag_ter = ',f_cdrag_ter
Index: /LMDZ5/branches/LMDZ_tree_FC/libf/phylmd/cv3_estatmix.F90
===================================================================
--- /LMDZ5/branches/LMDZ_tree_FC/libf/phylmd/cv3_estatmix.F90	(revision 2925)
+++ /LMDZ5/branches/LMDZ_tree_FC/libf/phylmd/cv3_estatmix.F90	(revision 2925)
@@ -0,0 +1,198 @@
+SUBROUTINE cv3_estatmix(len, nd, iflag, plim1, plim2, p, ph, &
+                       t, q, u, v, h, gz, w, &
+                       wi, nk, tmix, thmix, qmix, qsmix, umix, vmix, plcl)
+  ! **************************************************************
+  ! *
+  ! CV3_ESTATMIX  Determine the properties of an adiabatic updraft  *
+  !                made of air coming from several layers by        *
+  !                mixing static energy                             *
+  !                                                                 *
+  ! written by   : Grandpeix Jean-Yves, 28/12/2001, 13.14.24        *
+  ! modified by :  Filiberti M-A 06/2005 vectorisation              *
+  ! ****************************************************************
+
+  IMPLICIT NONE
+  ! ==============================================================
+
+  ! estatmix : determines theta, t, q, qs, u and v of the lifted mixture
+  ! made of air between plim1 and plim2 with weighting w.
+  ! If plim1 and plim2 fall within the same model layer, then theta, ... v
+  ! are those of that layer.
+  ! A minimum value (dpmin) is imposed upon plim1-plim2
+
+  ! ===============================================================
+
+  include "cvthermo.h"
+  include "YOETHF.h"
+  include "YOMCST.h"
+  include "FCTTRE.h"
+!inputs:
+  INTEGER, INTENT (IN)                      :: nd, len
+  INTEGER, DIMENSION (len), INTENT (IN)     :: nk
+  REAL, DIMENSION (len), INTENT (IN)        :: plim1, plim2
+  REAL, DIMENSION (len,nd), INTENT (IN)     :: t, q
+  REAL, DIMENSION (len,nd), INTENT (IN)     :: u, v
+  REAL, DIMENSION (len,nd), INTENT (IN)     :: h ! static energy of the layers
+  REAL, DIMENSION (len,nd), INTENT (IN)     :: gz
+  REAL, DIMENSION (nd), INTENT (IN)         :: w
+  REAL, DIMENSION (len,nd), INTENT (IN)     :: p
+  REAL, DIMENSION (len,nd+1), INTENT (IN)   :: ph
+!input/output:
+  INTEGER, DIMENSION (len), INTENT (INOUT)  ::  iflag
+!outputs:
+  REAL, DIMENSION (len), INTENT (OUT)       :: tmix, thmix, qmix
+  REAL, DIMENSION (len), INTENT (OUT)       :: umix, vmix
+  REAL, DIMENSION (len), INTENT (OUT)       :: qsmix
+  REAL, DIMENSION (len), INTENT (OUT)       :: plcl
+  REAL, DIMENSION (len,nd), INTENT (OUT)    :: wi
+!internal variables :
+  INTEGER i, j
+  INTEGER niflag7
+  INTEGER, DIMENSION(len)                   :: j1, j2
+  REAL                                      :: a, b
+  REAL                                      :: cpn
+  REAL                                      :: x, y, p0, zdelta, zcor
+  REAL                                      :: dpmin=1.
+!$OMP THREADPRIVATE(dpmin)
+  REAL, DIMENSION(len)                      :: plim2p  ! = min(plim2(:),plim1(:)-dpmin)
+  REAL, DIMENSION(len)                      :: dpw, coef
+  REAL, DIMENSION(len)                      :: hmix ! static energy of the updraft
+  REAL, DIMENSION(len)                      :: rdcp, pnk
+  REAL, DIMENSION(len)                      :: rh, chi
+  REAL, DIMENSION(len)                      :: eqwght
+  REAL, DIMENSION(len,nd)                   :: p1, p2
+
+
+!!  print *,' ->cv3_vertmix, plim1,plim2 ', plim1,plim2   !jyg
+  plim2p(:) = min(plim2(:),plim1(:)-dpmin)
+  j1(:)=nd
+  j2(:) = 0
+  DO j = 1, nd
+    DO i = 1, len
+      IF (plim1(i)<=ph(i,j)) j1(i) = j
+!!!      IF (plim2p(i)>=ph(i,j+1) .AND. plim2p(i)<ph(i,j)) j2(i) = j
+      IF (plim2p(i)< ph(i,j)) j2(i) = j
+    END DO
+  END DO
+
+  DO j = 1, nd
+    DO i = 1, len
+      wi(i, j) = 0.
+    END DO
+  END DO
+  DO i = 1, len
+    hmix(i) = 0.
+    qmix(i) = 0.
+    umix(i) = 0.
+    vmix(i) = 0.
+    dpw(i) = 0.
+    pnk(i) = p(i, nk(i))
+  END DO
+  eqwght(:) = 0.
+
+  p0 = 1000.
+
+  DO i = 1, len
+    IF (j2(i) < j1(i)) THEN
+      coef(i) = 1.
+      eqwght(i) = 1.
+    ELSE
+      coef(i) = 1./(plim1(i)-plim2p(i))
+    ENDIF
+  END DO
+
+!!  print *,'cv3_vertmix, j1,j2,coef ', j1,j2,coef  !jyg
+
+  DO j = 1, nd
+    DO i = 1, len
+      IF (j>=j1(i) .AND. j<=j2(i)) THEN
+        p1(i, j) = min(ph(i,j), plim1(i))
+        p2(i, j) = max(ph(i,j+1), plim2p(i))
+        ! CRtest:couplage thermiques: deja normalise
+        ! wi(i,j) = w(j)
+        ! print*,'wi',wi(i,j)
+        wi(i, j) = w(j)*(p1(i,j)-p2(i,j))*coef(i)+eqwght(i)
+        dpw(i) = dpw(i) + wi(i, j)
+
+!!  print *,'cv3_vertmix, j, wi(1,j),dpw ', j, wi(1,j),dpw  !jyg
+
+      END IF
+    END DO
+  END DO
+
+  ! CR:print
+  ! do i=1,len
+  ! print*,'plim',plim1(i),plim2p(i)
+  ! enddo
+  DO j = 1, nd
+    DO i = 1, len
+      IF (j>=j1(i) .AND. j<=j2(i)) THEN
+        wi(i, j) = wi(i, j)/dpw(i)
+        hmix(i) = hmix(i) + h(i, j)*wi(i, j)
+        qmix(i) = qmix(i) +  q(i, j)*wi(i, j)
+        umix(i) = umix(i) +  u(i, j)*wi(i, j)
+        vmix(i) = vmix(i) +  v(i, j)*wi(i, j)
+      END IF
+    END DO
+  END DO
+
+  DO i = 1, len
+    rdcp(i) = (rrd*(1.-qmix(i))+qmix(i)*rrv)/(cpd*(1.-qmix(i))+qmix(i)*cpv)
+  END DO
+
+
+!!  print *,'cv3_vertmix, rdcp ', rdcp  !jyg
+
+  DO i = 1, len
+    tmix(i) = (hmix(i) - gz(i,1))/(cpd*(1.-qmix(i)) + qmix(i)*cpv)
+    !      (Use of Cpv since we are dealing with dry static energy)
+    thmix(i) = tmix(i)*(p0/pnk(i))**rdcp(i)
+    ! print*,'tmix thmix hmix ',tmix(i),thmix(i),hmix(i)
+    zdelta = max(0., sign(1.,rtt-tmix(i)))
+    qsmix(i) = r2es*foeew(tmix(i), zdelta)/(pnk(i)*100.)
+    qsmix(i) = min(0.5, qsmix(i))
+    zcor = 1./(1.-retv*qsmix(i))
+    qsmix(i) = qsmix(i)*zcor
+  END DO
+
+  ! -------------------------------------------------------------------
+  ! --- Calculate lifted condensation level of air at parcel origin level
+  ! --- (Within 0.2% of formula of Bolton, MON. WEA. REV.,1980)
+  ! -------------------------------------------------------------------
+
+  a = 1669.0 ! convect3
+  b = 122.0 ! convect3
+
+
+  niflag7 = 0
+  DO i = 1, len
+
+    IF (iflag(i)/=7) THEN ! modif sb Jun7th 2002
+
+      rh(i) = qmix(i)/qsmix(i)
+      chi(i) = tmix(i)/(a-b*rh(i)-tmix(i)) ! convect3
+      ! ATTENTION, la LIGNE DESSOUS A ETE RAJOUTEE ARBITRAIREMENT ET
+      ! MASQUE UN PB POTENTIEL
+      chi(i) = max(chi(i), 0.)
+      rh(i) = max(rh(i), 0.)
+      plcl(i) = pnk(i)*(rh(i)**chi(i))
+      IF (((plcl(i)<200.0) .OR. (plcl(i)>=2000.0)) .AND. (iflag(i)==0)) &
+          iflag(i) = 8
+
+    ELSE
+
+      niflag7 = niflag7 + 1
+      plcl(i) = plim2p(i)
+
+    END IF ! iflag=7
+
+    ! print*,'NIFLAG7  =',niflag7
+
+  END DO
+
+!!  print *,' cv3_vertmix->'  !jyg
+
+
+  RETURN
+END SUBROUTINE cv3_estatmix
+
Index: /LMDZ5/branches/LMDZ_tree_FC/libf/phylmd/cv3_routines.F90
===================================================================
--- /LMDZ5/branches/LMDZ_tree_FC/libf/phylmd/cv3_routines.F90	(revision 2924)
+++ /LMDZ5/branches/LMDZ_tree_FC/libf/phylmd/cv3_routines.F90	(revision 2925)
@@ -111,4 +111,9 @@
      ok_optim_yield=.False.
      CALL getin_p('ok_optim_yield',ok_optim_yield)
+     ok_homo_tend=.TRUE.
+     CALL getin_p('ok_homo_tend',ok_homo_tend)
+     ok_entrain=.TRUE.
+     CALL getin_p('ok_entrain',ok_entrain)
+
      coef_peel=0.25
      CALL getin_p('coef_peel',coef_peel)
@@ -277,5 +282,5 @@
 
 SUBROUTINE cv3_feed(len, nd, ok_conserv_q, &
-                    t, q, u, v, p, ph, hm, gz, &
+                    t, q, u, v, p, ph, h, gz, &
                     p1feed, p2feed, wght, &
                     wghti, tnk, thnk, qnk, qsnk, unk, vnk, &
@@ -283,4 +288,5 @@
 
   USE mod_phys_lmdz_transfert_para, ONLY : bcast
+  USE add_phys_tend_mod, ONLY: fl_cor_ebil
   IMPLICIT NONE
 
@@ -292,4 +298,5 @@
 ! - here, nk(i)=minorig
 ! - icb defined differently (plcl compared with ph instead of p)
+! - dry static energy as argument instead of moist static energy
 
 ! Main differences with convect3:
@@ -307,5 +314,5 @@
   REAL, DIMENSION (len, nd), INTENT (IN)             :: t, q, p
   REAL, DIMENSION (len, nd), INTENT (IN)             :: u, v
-  REAL, DIMENSION (len, nd), INTENT (IN)             :: hm, gz
+  REAL, DIMENSION (len, nd), INTENT (IN)             :: h, gz
   REAL, DIMENSION (len, nd+1), INTENT (IN)           :: ph
   REAL, DIMENSION (len), INTENT (IN)                 :: p1feed
@@ -378,14 +385,26 @@
     pup(i) = p2feed(i)
   END DO
-  CALL cv3_vertmix(len, nd, iflag, p1feed, pup, p, ph, &
-                   t, q, u, v, wght, &
-                   wghti, nk, tnk, thnk, qnk, qsnk, unk, vnk, plclup)
+  IF (fl_cor_ebil >=2 ) THEN
+    CALL cv3_estatmix(len, nd, iflag, p1feed, pup, p, ph, &
+                     t, q, u, v, h, gz, wght, &
+                     wghti, nk, tnk, thnk, qnk, qsnk, unk, vnk, plclup)
+  ELSE
+    CALL cv3_enthalpmix(len, nd, iflag, p1feed, pup, p, ph, &
+                       t, q, u, v, wght, &
+                       wghti, nk, tnk, thnk, qnk, qsnk, unk, vnk, plclup)
+  ENDIF  ! (fl_cor_ebil >=2 ) 
 ! 1.b- LCL associated with ph(nk+1)
   DO i = 1, len
     plo(i) = ph(i, nk(i)+1)
   END DO
-  CALL cv3_vertmix(len, nd, iflag, p1feed, plo, p, ph, &
-                   t, q, u, v, wght, &
-                   wghti, nk, tnk, thnk, qnk, qsnk, unk, vnk, plcllo)
+  IF (fl_cor_ebil >=2 ) THEN
+    CALL cv3_estatmix(len, nd, iflag, p1feed, plo, p, ph, &
+                     t, q, u, v, h, gz, wght, &
+                     wghti, nk, tnk, thnk, qnk, qsnk, unk, vnk, plcllo)
+  ELSE
+    CALL cv3_enthalpmix(len, nd, iflag, p1feed, plo, p, ph, &
+                       t, q, u, v, wght, &
+                       wghti, nk, tnk, thnk, qnk, qsnk, unk, vnk, plcllo)
+  ENDIF  ! (fl_cor_ebil >=2 ) 
 ! 2- Iterations
   niter = 5
@@ -434,7 +453,13 @@
 !jyg>
 
-    CALL cv3_vertmix(len, nd, iflag, p1feed, pfeed, p, ph, &
-                   t, q, u, v, wght, &
-                   wghti, nk, tnk, thnk, qnk, qsnk, unk, vnk, plclfeed)
+    IF (fl_cor_ebil >=2 ) THEN
+      CALL cv3_estatmix(len, nd, iflag, p1feed, pfeed, p, ph, &
+                       t, q, u, v, h, gz, wght, &
+                       wghti, nk, tnk, thnk, qnk, qsnk, unk, vnk, plclfeed)
+    ELSE
+      CALL cv3_enthalpmix(len, nd, iflag, p1feed, pfeed, p, ph, &
+                         t, q, u, v, wght, &
+                         wghti, nk, tnk, thnk, qnk, qsnk, unk, vnk, plclfeed)
+    ENDIF  ! (fl_cor_ebil >=2 ) 
 !jyg20140217<
     IF (ok_new_feed) THEN
@@ -1647,4 +1672,10 @@
       DO i = 1, ncum
         IF ((k>=icb(i)) .AND. (k<=inb(i))) THEN
+!jyg<   (energy conservation tests)
+!!          hp(i, k) = hnk(i) + (lv(i,k)+(cpd-cpv)*tp(i,k))*ep(i, k)*clw(i, k)
+!!          hp(i, k) = ( hnk(i) + (lv(i,k)+(cpd-cpv)*t(i,k))*ep(i, k)*clw(i, k) ) / &
+!!                     (1. - ep(i,k)*clw(i,k))
+!!          hp(i, k) = ( hnk(i) + (lv(i,k)+(cpd-cl)*t(i,k))*ep(i, k)*clw(i, k) ) / &
+!!                     (1. - ep(i,k)*clw(i,k))
           hp(i, k) = hnk(i) + (lv(i,k)+(cpd-cpv)*t(i,k))*ep(i, k)*clw(i, k)
         END IF
@@ -2984,4 +3015,7 @@
                      qcondc, wd, &
                      ftd, fqd, qnk, qtc, sigt, tau_cld_cv, coefw_cld_cv)
+
+    USE print_control_mod, ONLY: lunout, prt_level
+    USE add_phys_tend_mod, only : fl_cor_ebil
 
   IMPLICIT NONE
@@ -3220,6 +3254,13 @@
 
       IF ((0.01*grav*work(il)*am(il))>=delti) iflag(il) = 1 !consist vect
-      ft(il, 1) = ft(il, 1) + 0.01*grav*work(il)*am(il) * &
-                                   (t(il,2)-t(il,1)+(gz(il,2)-gz(il,1))/cpn(il,1))
+!jyg<
+        IF (fl_cor_ebil >= 2) THEN
+          ft(il, 1) = ft(il, 1) + 0.01*grav*work(il)*am(il) * &
+                    ((t(il,2)-t(il,1))*cpn(il,2)+gz(il,2)-gz(il,1))/cpn(il,1)
+        ELSE
+          ft(il, 1) = ft(il, 1) + 0.01*grav*work(il)*am(il) * &
+                    (t(il,2)-t(il,1)+(gz(il,2)-gz(il,1))/cpn(il,1))
+        ENDIF
+!>jyg
     END IF ! iflag
   END DO
@@ -3529,7 +3570,15 @@
 
 ! sature
-        ft(il, i) = ft(il, i) + 0.01*grav*dpinv * &
+!jyg<
+        IF (fl_cor_ebil >= 2) THEN
+          ft(il, i) = ft(il, i) + 0.01*grav*dpinv * &
+              ( amp1(il)*( (t(il,i+1)-t(il,i))*cpn(il,i+1) + gz(il,i+1)-gz(il,i))*cpinv - &
+                ad(il)*( (t(il,i)-t(il,i-1))*cpn(il,i-1) + gz(il,i)-gz(il,i-1))*cpinv)
+        ELSE
+          ft(il, i) = ft(il, i) + 0.01*grav*dpinv * &
                      (amp1(il)*(t(il,i+1)-t(il,i) + (gz(il,i+1)-gz(il,i))*cpinv) - &
                       ad(il)*(t(il,i)-t(il,i-1)+(gz(il,i)-gz(il,i-1))*cpinv))
+        ENDIF
+!>jyg
 
 
@@ -3538,7 +3587,5 @@
                                     t(il,i)*(cpv-cpd)*(rr(il,i)-qent(il,i,i)))*cpinv
         END IF
-
-
-
+!
 ! sb: on ne fait pas encore la correction permettant de mieux
 ! conserver l'eau:
@@ -3873,14 +3920,16 @@
 
 !!!!      do 700 i=1,icb(il)-1
-  DO i = 1, nl
-    DO il = 1, ncum
-      IF (i<=(icb(il)-1) .AND. iflag(il)<=1) THEN
-        ftd(il, i) = esum(il)*t_wake(il, i)/(th_wake(il,i)*hsum(il))
-        fqd(il, i) = fsum(il)/gsum(il)
-        ft(il, i) = ftd(il, i) + asum(il)*t(il, i)/(th(il,i)*dsum(il))
-        fr(il, i) = fqd(il, i) + bsum(il)/csum(il)
-      END IF
-    END DO
-  END DO
+  IF (ok_homo_tend) THEN
+    DO i = 1, nl
+      DO il = 1, ncum
+        IF (i<=(icb(il)-1) .AND. iflag(il)<=1) THEN
+          ftd(il, i) = esum(il)*t_wake(il, i)/(th_wake(il,i)*hsum(il))
+          fqd(il, i) = fsum(il)/gsum(il)
+          ft(il, i) = ftd(il, i) + asum(il)*t(il, i)/(th(il,i)*dsum(il))
+          fr(il, i) = fqd(il, i) + bsum(il)/csum(il)
+        END IF
+      END DO
+    END DO
+  ENDIF
 
 !jyg<
@@ -3920,5 +3969,7 @@
   END DO
 !
-!    print *,' YIELD : alpha_qpos ',alpha_qpos(1)
+    IF (prt_level .GE. 5) THEN
+      print *,' CV3_YIELD : alpha_qpos ',alpha_qpos(1)
+    ENDIF
 !
   DO il = 1, ncum
Index: /LMDZ5/branches/LMDZ_tree_FC/libf/phylmd/cv3p_mixing.F90
===================================================================
--- /LMDZ5/branches/LMDZ_tree_FC/libf/phylmd/cv3p_mixing.F90	(revision 2924)
+++ /LMDZ5/branches/LMDZ_tree_FC/libf/phylmd/cv3p_mixing.F90	(revision 2925)
@@ -14,4 +14,6 @@
 
   USE print_control_mod, ONLY: mydebug=>debug , lunout, prt_level
+  USE ioipsl_getin_p_mod, ONLY: getin_p
+  USE add_phys_tend_mod, ONLY: fl_cor_ebil
 
   IMPLICIT NONE
@@ -110,5 +112,5 @@
             fmax, gammas, qqa1, qqa2, Qcoef1max, Qcoef2max
 !>jyg
-
+!
   END IF
 
@@ -165,58 +167,64 @@
   DO i = minorig + 1, nl
 
-    DO j = minorig, nl
-      DO il = 1, ncum
-        IF ((i>=icb(il)) .AND. (i<=inb(il)) .AND. (j>=(icb(il)-1)) &
-                         .AND. (j<=inb(il))) THEN
-
-          rti = qnk(il) - ep(il, i)*clw(il, i)
-          bf2 = 1. + lv(il, j)*lv(il, j)*rs(il, j)/(rrv*t(il,j)*t(il,j)*cpd)
-!jyg(from aj)<
-          IF (cvflag_ice) THEN
-! print*,cvflag_ice,'cvflag_ice dans do 700'
-            IF (t(il,j)<=263.15) THEN
-              bf2 = 1. + (lf(il,j)+lv(il,j))*(lv(il,j)+frac(il,j)* &
-                   lf(il,j))*rs(il, j)/(rrv*t(il,j)*t(il,j)*cpd)
-            END IF
-          END IF
-!>jyg
-          anum = h(il, j) - hp(il, i) + (cpv-cpd)*t(il, j)*(rti-rr(il,j))
-          denom = h(il, i) - hp(il, i) + (cpd-cpv)*(rr(il,i)-rti)*t(il, j)
-          dei = denom
-          IF (abs(dei)<0.01) dei = 0.01
-          Sij(il, i, j) = anum/dei
-          Sij(il, i, i) = 1.0
-          altem = Sij(il, i, j)*rr(il, i) + (1.-Sij(il,i,j))*rti - rs(il, j)
-          altem = altem/bf2
-          cwat = clw(il, j)*(1.-ep(il,j))
-          stemp = Sij(il, i, j)
-          IF ((stemp<0.0 .OR. stemp>1.0 .OR. altem>cwat) .AND. j>i) THEN
+    IF (ok_entrain) THEN
+      DO j = minorig, nl
+        DO il = 1, ncum
+          IF ((i>=icb(il)) .AND. (i<=inb(il)) .AND. (j>=(icb(il)-1)) &
+                           .AND. (j<=inb(il))) THEN
+
+            rti = qnk(il) - ep(il, i)*clw(il, i)
+            bf2 = 1. + lv(il, j)*lv(il, j)*rs(il, j)/(rrv*t(il,j)*t(il,j)*cpd)
 !jyg(from aj)<
             IF (cvflag_ice) THEN
-              anum = anum - (lv(il,j)+frac(il,j)*lf(il,j))*(rti-rs(il,j)-cwat*bf2)
-              denom = denom + (lv(il,j)+frac(il,j)*lf(il,j))*(rr(il,i)-rti)
-            ELSE
-              anum = anum - lv(il, j)*(rti-rs(il,j)-cwat*bf2)
-              denom = denom + lv(il, j)*(rr(il,i)-rti)
+! print*,cvflag_ice,'cvflag_ice dans do 700'
+              IF (t(il,j)<=263.15) THEN
+                bf2 = 1. + (lf(il,j)+lv(il,j))*(lv(il,j)+frac(il,j)* &
+                     lf(il,j))*rs(il, j)/(rrv*t(il,j)*t(il,j)*cpd)
+              END IF
             END IF
 !>jyg
-            IF (abs(denom)<0.01) denom = 0.01
-            Sij(il, i, j) = anum/denom
+            anum = h(il, j) - hp(il, i) + (cpv-cpd)*t(il, j)*(rti-rr(il,j))
+            denom = h(il, i) - hp(il, i) + (cpd-cpv)*(rr(il,i)-rti)*t(il, j)
+            dei = denom
+            IF (abs(dei)<0.01) dei = 0.01
+            Sij(il, i, j) = anum/dei
+            Sij(il, i, i) = 1.0
             altem = Sij(il, i, j)*rr(il, i) + (1.-Sij(il,i,j))*rti - rs(il, j)
-            altem = altem - (bf2-1.)*cwat
-          END IF
-          IF (Sij(il,i,j)>0.0) THEN
+            altem = altem/bf2
+            cwat = clw(il, j)*(1.-ep(il,j))
+            stemp = Sij(il, i, j)
+            IF ((stemp<0.0 .OR. stemp>1.0 .OR. altem>cwat) .AND. j>i) THEN
+!jyg(from aj)<
+              IF (cvflag_ice) THEN
+                anum = anum - (lv(il,j)+frac(il,j)*lf(il,j))*(rti-rs(il,j)-cwat*bf2)
+                denom = denom + (lv(il,j)+frac(il,j)*lf(il,j))*(rr(il,i)-rti)
+              ELSE
+                anum = anum - lv(il, j)*(rti-rs(il,j)-cwat*bf2)
+                denom = denom + lv(il, j)*(rr(il,i)-rti)
+              END IF
+!>jyg
+              IF (abs(denom)<0.01) denom = 0.01
+              Sij(il, i, j) = anum/denom
+              altem = Sij(il, i, j)*rr(il, i) + (1.-Sij(il,i,j))*rti - rs(il, j)
+              altem = altem - (bf2-1.)*cwat
+            END IF
+            IF (Sij(il,i,j)>0.0) THEN
 !!!                 Ment(il,i,j)=m(il,i)
-            Ment(il, i, j) = 1.
-            elij(il, i, j) = altem
-            elij(il, i, j) = amax1(0.0, elij(il,i,j))
-            nent(il, i) = nent(il, i) + 1
-          END IF
-
-          Sij(il, i, j) = amax1(0.0, Sij(il,i,j))
-          Sij(il, i, j) = amin1(1.0, Sij(il,i,j))
-        END IF ! new
-      END DO
-    END DO
+              Ment(il, i, j) = 1.
+              elij(il, i, j) = altem
+              elij(il, i, j) = amax1(0.0, elij(il,i,j))
+              nent(il, i) = nent(il, i) + 1
+            END IF
+
+            Sij(il, i, j) = amax1(0.0, Sij(il,i,j))
+            Sij(il, i, j) = amin1(1.0, Sij(il,i,j))
+          END IF ! new
+        END DO
+      END DO
+    ELSE  ! (ok_entrain)
+      DO il = 1,ncum
+        nent(il,i) = 0
+      ENDDO
+    ENDIF ! (ok_entrain)
 
 !jygdebug<
@@ -243,9 +251,12 @@
         uent(il, i, i) = unk(il)
         vent(il, i, i) = vnk(il)
+        IF (fl_cor_ebil .GE. 2) THEN
+          hent(il, i, i) = hp(il,i)
+        ENDIF
         elij(il, i, i) = clw(il, i)*(1.-ep(il,i))
         Sij(il, i, i) = 0.0
       END IF
     END DO
-  END DO
+  END DO ! i = minorig + 1, nl
 
 !jyg!  DO j = 1, ntra
@@ -652,5 +663,10 @@
         vent(il, i, i) = vnk(il)
         elij(il, i, i) = clw(il, i)*(1.-ep(il,i))
-        Sij(il, i, i) = 0.0
+        IF (fl_cor_ebil .GE. 2) THEN
+          hent(il, i, i) = hp(il,i)
+          Sigij(il, i, i) = 0.0
+        ELSE
+          Sij(il, i, i) = 0.0
+        ENDIF
       END IF
     END DO ! il
Index: /LMDZ5/branches/LMDZ_tree_FC/libf/phylmd/cv3param.h
===================================================================
--- /LMDZ5/branches/LMDZ_tree_FC/libf/phylmd/cv3param.h	(revision 2924)
+++ /LMDZ5/branches/LMDZ_tree_FC/libf/phylmd/cv3param.h	(revision 2925)
@@ -7,5 +7,7 @@
 !------------------------------------------------------------
 
+      logical ok_homo_tend
       logical ok_optim_yield
+      logical ok_entrain
       logical ok_convstop
       logical ok_intermittent
@@ -41,5 +43,7 @@
                       ,noff, minorig, nl, nlp, nlm  &
                       ,ok_convstop, ok_intermittent &
-                      ,ok_optim_yield
+                      ,ok_optim_yield &
+                      ,ok_entrain &
+                      ,ok_homo_tend
 !$OMP THREADPRIVATE(/cv3param/)
 
Index: /LMDZ5/branches/LMDZ_tree_FC/libf/phylmd/cva_driver.F90
===================================================================
--- /LMDZ5/branches/LMDZ_tree_FC/libf/phylmd/cva_driver.F90	(revision 2924)
+++ /LMDZ5/branches/LMDZ_tree_FC/libf/phylmd/cva_driver.F90	(revision 2925)
@@ -40,4 +40,5 @@
 
   USE print_control_mod, ONLY: prt_level, lunout
+  USE add_phys_tend_mod, ONLY: fl_cor_ebil
   IMPLICIT NONE
 
@@ -730,5 +731,5 @@
              PRINT *, 'cva_driver -> cv3_feed'
     CALL cv3_feed(len, nd, ok_conserv_q, &                 ! nd->na
-                  t1, q1, u1, v1, p1, ph1, hm1, gz1, & 
+                  t1, q1, u1, v1, p1, ph1, h1, gz1, & 
                   p1feed1, p2feed1, wght1, &
                   wghti1, tnk1, thnk1, qnk1, qsnk1, unk1, vnk1, &
Index: /LMDZ5/branches/LMDZ_tree_FC/libf/phylmd/dyn1d/1DUTILS.h
===================================================================
--- /LMDZ5/branches/LMDZ_tree_FC/libf/phylmd/dyn1d/1DUTILS.h	(revision 2924)
+++ /LMDZ5/branches/LMDZ_tree_FC/libf/phylmd/dyn1d/1DUTILS.h	(revision 2925)
@@ -482,4 +482,18 @@
        forc_omega =0
        CALL getin('forc_omega',forc_omega)
+
+!Config  Key  = forc_u
+!Config  Desc = forcage ou non par u
+!Config  Def  = false
+!Config  Help = forcage ou non par u
+       forc_u =0
+       CALL getin('forc_u',forc_u)
+
+!Config  Key  = forc_v
+!Config  Desc = forcage ou non par v
+!Config  Def  = false
+!Config  Help = forcage ou non par v
+       forc_v =0
+       CALL getin('forc_v',forc_v)
 
 !Config  Key  = forc_w
@@ -653,12 +667,9 @@
 
       modname = 'dyn1deta0 : '
-!!      nmq(1)="vap"
-!!      nmq(2)="cond"
-!!      do iq=3,nqtot
-!!        write(nmq(iq),'("tra",i1)') iq-2
-!!      enddo
-      DO iq = 1,nqtot
-        nmq(iq) = trim(tname(iq))
-      ENDDO
+      nmq(1)="vap"
+      nmq(2)="cond"
+      do iq=3,nqtot
+        write(nmq(iq),'("tra",i1)') iq-2
+      enddo
       print*,'in dyn1deta0 ',fichnom,klon,klev,nqtot
       CALL open_startphy(fichnom)
@@ -807,11 +818,8 @@
       CALL open_restartphy(fichnom)
       print*,'redm1 ',fichnom,klon,klev,nqtot
-!!      nmq(1)="vap"
-!!      nmq(2)="cond"
-!!      nmq(3)="tra1"
-!!      nmq(4)="tra2"
-      DO iq = 1,nqtot
-        nmq(iq) = trim(tname(iq))
-      ENDDO
+      nmq(1)="vap"
+      nmq(2)="cond"
+      nmq(3)="tra1"
+      nmq(4)="tra2"
 
       modname = 'dyn1dredem'
@@ -1396,5 +1404,4 @@
       cor(:) = rkappa*temp*(1.+q(:,1)*rv/rd)/(play*(1.+q(:,1)))
 
-
       do k=2,llm-1
 
@@ -2789,5 +2796,4 @@
          hq_mod_cas(l)= hq_prof_cas(k2) - frac*(hq_prof_cas(k2)-hq_prof_cas(k1))
          vq_mod_cas(l)= vq_prof_cas(k2) - frac*(vq_prof_cas(k2)-vq_prof_cas(k1))
-         dtrad_mod_cas(l)= dtrad_prof_cas(k2) - frac*(dtrad_prof_cas(k2)-dtrad_prof_cas(k1))
      
          else !play>plev_prof_cas(1)
@@ -2816,5 +2822,4 @@
          hq_mod_cas(l)= frac1*hq_prof_cas(k1) - frac2*hq_prof_cas(k2)
          vq_mod_cas(l)= frac1*vq_prof_cas(k1) - frac2*vq_prof_cas(k2)
-         dtrad_mod_cas(l)= frac1*dtrad_prof_cas(k1) - frac2*dtrad_prof_cas(k2)
 
          endif ! play.le.plev_prof_cas(1)
@@ -2845,5 +2850,4 @@
          hq_mod_cas(l)= hq_prof_cas(nlev_cas)*fact                            !jyg
          vq_mod_cas(l)= vq_prof_cas(nlev_cas)*fact                            !jyg
-         dtrad_mod_cas(l)= dtrad_prof_cas(nlev_cas)*fact                      !jyg
  
         endif ! play
@@ -5171,5 +5175,4 @@
          hq_mod_cas(l)= hq_prof_cas(k2) - frac*(hq_prof_cas(k2)-hq_prof_cas(k1))
          vq_mod_cas(l)= vq_prof_cas(k2) - frac*(vq_prof_cas(k2)-vq_prof_cas(k1))
-         dtrad_mod_cas(l)= dtrad_prof_cas(k2) - frac*(dtrad_prof_cas(k2)-dtrad_prof_cas(k1))
      
          else !play>plev_prof_cas(1)
@@ -5208,5 +5211,4 @@
          hq_mod_cas(l)= frac1*hq_prof_cas(k1) - frac2*hq_prof_cas(k2)
          vq_mod_cas(l)= frac1*vq_prof_cas(k1) - frac2*vq_prof_cas(k2)
-         dtrad_mod_cas(l)= frac1*dtrad_prof_cas(k1) - frac2*dtrad_prof_cas(k2)
 
          endif ! play.le.plev_prof_cas(1)
@@ -5245,5 +5247,4 @@
          hq_mod_cas(l)= hq_prof_cas(nlev_cas)*fact                     !jyg
          vq_mod_cas(l)= vq_prof_cas(nlev_cas)*fact                     !jyg
-         dtrad_mod_cas(l)= dtrad_prof_cas(nlev_cas)*fact               !jyg
  
         endif ! play
